#include <psp2/kernel/clib.h>
#include <psp2/kernel/processmgr.h>
// #include <debugnet.h>

#include "stdlib.h"

#include "context.h"
#include "config.h"

VitaChiakiContext context;

void log_cb_debugnet(ChiakiLogLevel lvl, const char *msg, void *user) {
  // int debugnet_lvl;
  // switch (lvl) {
  //   case CHIAKI_LOG_ERROR:
  //   case CHIAKI_LOG_WARNING:
  //     debugnet_lvl = ERROR;
  //     break;
  //   case CHIAKI_LOG_INFO:
  //     debugnet_lvl = INFO;
  //     break;
  //   // case CHIAKI_LOG_VERBOSE:
  //   case CHIAKI_LOG_DEBUG:
  //   // case CHIAKI_LOG_ALL:
  //     debugnet_lvl = DEBUG;
  //     break;
  //   default:
  //     return;
  // }
  if (lvl == CHIAKI_LOG_ALL || lvl == CHIAKI_LOG_VERBOSE) return;
  // uint64_t timestamp = sceKernelGetProcessTimeWide();
  sceClibPrintf("[CHIAKI] %s\n", msg);
}

bool vita_chiaki_init_context() {
  config_parse(&context.config);

  // TODO: Load log level from config
  // TODO: Custom logging callback that logs to a file
  chiaki_log_init(&(context.log), CHIAKI_LOG_ALL & ~(CHIAKI_LOG_VERBOSE | CHIAKI_LOG_DEBUG), &log_cb_debugnet, NULL);
  return true;
}